/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package com.qsoft.rs.sincoar.model;

import java.io.Serializable;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.util.Collection;
import java.util.Date;
import javax.persistence.Basic;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;

/**
 *
 * @author developer2
 */
@Entity
@Table(name="COMACO.MIGR_DATATYPE_TRANSFORM_MAP")
@XmlRootElement
@NamedQueries({
    @NamedQuery(name = "MigrDatatypeTransformMap.findAll", query = "SELECT m FROM MigrDatatypeTransformMap m"),
    @NamedQuery(name = "MigrDatatypeTransformMap.findById", query = "SELECT m FROM MigrDatatypeTransformMap m WHERE m.id = :id"),
    @NamedQuery(name = "MigrDatatypeTransformMap.findByMapName", query = "SELECT m FROM MigrDatatypeTransformMap m WHERE m.mapName = :mapName"),
    @NamedQuery(name = "MigrDatatypeTransformMap.findBySecurityGroupId", query = "SELECT m FROM MigrDatatypeTransformMap m WHERE m.securityGroupId = :securityGroupId"),
    @NamedQuery(name = "MigrDatatypeTransformMap.findByCreatedOn", query = "SELECT m FROM MigrDatatypeTransformMap m WHERE m.createdOn = :createdOn"),
    @NamedQuery(name = "MigrDatatypeTransformMap.findByCreatedBy", query = "SELECT m FROM MigrDatatypeTransformMap m WHERE m.createdBy = :createdBy"),
    @NamedQuery(name = "MigrDatatypeTransformMap.findByLastUpdatedOn", query = "SELECT m FROM MigrDatatypeTransformMap m WHERE m.lastUpdatedOn = :lastUpdatedOn"),
    @NamedQuery(name = "MigrDatatypeTransformMap.findByLastUpdatedBy", query = "SELECT m FROM MigrDatatypeTransformMap m WHERE m.lastUpdatedBy = :lastUpdatedBy")})
public class MigrDatatypeTransformMap implements Serializable {

    private static final long serialVersionUID = 1L;
    // @Max(value=?)  @Min(value=?)//if you know range of your decimal fields consider using these annotations to enforce field validation
    @Id
    @Basic(optional = false)
    @Column(name = "ID")
    private BigDecimal id;
    @Column(name = "MAP_NAME")
    private String mapName;
    @Basic(optional = false)
    @Column(name = "SECURITY_GROUP_ID")
    private BigInteger securityGroupId;
    @Basic(optional = false)
    @Column(name = "CREATED_ON")
    @Temporal(TemporalType.TIMESTAMP)
    private Date createdOn;
    @Column(name = "CREATED_BY")
    private String createdBy;
    @Column(name = "LAST_UPDATED_ON")
    @Temporal(TemporalType.TIMESTAMP)
    private Date lastUpdatedOn;
    @Column(name = "LAST_UPDATED_BY")
    private String lastUpdatedBy;
    @OneToMany(cascade = CascadeType.ALL, mappedBy = "mapIdFk")
    private Collection<MigrDatatypeTransformRule> migrDatatypeTransformRuleCollection;
    @JoinColumn(name = "PROJECT_ID_FK", referencedColumnName = "ID")
    @ManyToOne(optional = false)
    private MdProjects projectIdFk;

    public MigrDatatypeTransformMap() {
    }

    public MigrDatatypeTransformMap(BigDecimal id) {
        this.id = id;
    }

    public MigrDatatypeTransformMap(BigDecimal id, BigInteger securityGroupId, Date createdOn) {
        this.id = id;
        this.securityGroupId = securityGroupId;
        this.createdOn = createdOn;
    }

    public BigDecimal getId() {
        return id;
    }

    public void setId(BigDecimal id) {
        this.id = id;
    }

    public String getMapName() {
        return mapName;
    }

    public void setMapName(String mapName) {
        this.mapName = mapName;
    }

    public BigInteger getSecurityGroupId() {
        return securityGroupId;
    }

    public void setSecurityGroupId(BigInteger securityGroupId) {
        this.securityGroupId = securityGroupId;
    }

    public Date getCreatedOn() {
        return createdOn;
    }

    public void setCreatedOn(Date createdOn) {
        this.createdOn = createdOn;
    }

    public String getCreatedBy() {
        return createdBy;
    }

    public void setCreatedBy(String createdBy) {
        this.createdBy = createdBy;
    }

    public Date getLastUpdatedOn() {
        return lastUpdatedOn;
    }

    public void setLastUpdatedOn(Date lastUpdatedOn) {
        this.lastUpdatedOn = lastUpdatedOn;
    }

    public String getLastUpdatedBy() {
        return lastUpdatedBy;
    }

    public void setLastUpdatedBy(String lastUpdatedBy) {
        this.lastUpdatedBy = lastUpdatedBy;
    }

    @XmlTransient
    public Collection<MigrDatatypeTransformRule> getMigrDatatypeTransformRuleCollection() {
        return migrDatatypeTransformRuleCollection;
    }

    public void setMigrDatatypeTransformRuleCollection(Collection<MigrDatatypeTransformRule> migrDatatypeTransformRuleCollection) {
        this.migrDatatypeTransformRuleCollection = migrDatatypeTransformRuleCollection;
    }

    public MdProjects getProjectIdFk() {
        return projectIdFk;
    }

    public void setProjectIdFk(MdProjects projectIdFk) {
        this.projectIdFk = projectIdFk;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (id != null ? id.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof MigrDatatypeTransformMap)) {
            return false;
        }
        MigrDatatypeTransformMap other = (MigrDatatypeTransformMap) object;
        if ((this.id == null && other.id != null) || (this.id != null && !this.id.equals(other.id))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "com.qsoft.rs.sincoar.model.MigrDatatypeTransformMap[ id=" + id + " ]";
    }
    
}
